﻿
BusMarkers = [];
KMZLayers = [];

function GetBuses(StopNo, BusNo, BusDirection, Agency) {
    var BusQS = '';

    if (BusNo.indexOf(',') > -1) {
        var BA = BusNo.split(',')
        var DA = BusDirection.split(',');

    $.each(BA, function (key, val) {
            BusQS += "&BusNum" + key + "=" + val + "&Direction" + key + "=" + encodeURIComponent(DA[key]);
        });
    } else {
        BusQS = '&BusNum0=' + BusNo + '&Direction0=' + encodeURIComponent(BusDirection);
    }

    $.mobile.loading("show", {
        text: Lang.GetTranslation('RetrievingBuses'),
        textVisible: true,
        theme: "a",
        html: ""
    });
    var URL = "https://www.BusTracker.ca/ajax/BusAPI.ashx?StopNo=" + StopNo + BusQS + "&Agency=" + Agency;

    $.ajax({
        dataType: 'json',
        url: URL,
        timeout: 12000,
        success: function (data) {
            
            if (data.StopDescription == '') {
                Popup(Lang.GetTranslation('NoStop'));
            } else if (data.Error.length > 0) {
                Popup(Lang.GetTranslation("FeedDown"));
            } else {
                if (data.Buses == '') {
                    Popup(Lang.GetTranslation('NoBusesRunning'));
                } else {
                    $('#h1BusTitle').text(data.StopDescription);
                    var BusList = [];
                    var items = [];
                    var TripsFound = false;
                    var BusNum = 0;
                    var GABuses = [];
                    var Trips = [];
                    KMZs = [];

                    $.each(data.Buses, function (key, val) {

                        if (val.KMZ != "")
                            KMZs.push(val.KMZ);

                        $.each(val.Trips, function (key1, val1) {
                            TripsFound = true;
                            Trips.push(val1);
                        });
                    });


                    if (TripsFound) {
                        Trips = Trips.sort(function (a, b) {
                            if (a.AdjustedScheduleTime < b.AdjustedScheduleTime) {
                                return -1;
                            }

                            if (a.AdjustedScheduleTime == b.AdjustedScheduleTime) {
                                return 0;
                            }

                            if (a.AdjustedScheduleTime > b.AdjustedScheduleTime) {
                                return 1;
                            }
                        });

                        $.each(Trips, function (key1, val1) {

                            if ($.inArray(val1.Number, GABuses) == -1)
                                GABuses.push(val1.Number);

                            if (val1.AdjustedScheduleTime == 1)
                                var time = Lang.GetTranslation("Minute");
                            else
                                var time = Lang.GetTranslation("Minutes");
                                

                            var Click = "";
                            if (val1.HasGPS) {
                                BusList.push(val1);
                                if (Lang.GetTranslation("AllowBusClick"))
                                    Click = " onclick='ShowBus(" + BusNum + ", this);' ";
                                BusNum++;
                                var Scheduled = '';
                            } else {
                                var Scheduled = Lang.GetTranslation("Scheduled");
                                if (Lang.GetTranslation("AllowBusClick"))
                                    Click = " onclick='ShowBus(-1, this);' ";
                            }


                            items.push("<li id='" + key1 + "'><a href='#' " + Click + " class='ui-btn'>" + val1.Number + " " + val1.Destination + "<span class='ui-li-count'>" + val1.AdjustedScheduleTime + " " + time + Scheduled + "</span></a></li>");

                        });



                        $("#lvBuses").html(items.join(''));
                        if ($('#lvBuses').hasClass('ui-listview'))
                            $('#lvBuses').listview("refresh");

                        $('#aSaveFavoriteBus').unbind('click');
                        $('#aSaveFavoriteBus').click(function () { AddFavoriteBus(StopNo, data.StopDescription, BusNo, BusDirection, Agency) });
                        $('#aSaveFavoriteBus').toggleClass('ui-btn-active', IsBusInFavorites(StopNo, BusNo, BusDirection));

                        $('#aRefresh').attr('href', 'javascript:GetBuses(' + StopNo + ',"' + BusNo + '","' + BusDirection + '","' + Agency + '");');

                        $('#aRefresh').removeClass('ui-btn-active');
                        $('#aBackBuses').removeClass('ui-btn-active');

                        jQuery.mobile.changePage('#pgBuses');

                        LoadBusMap(data.StopLat, data.StopLong, data.StopDescription, BusList);

                        var bs = "";
                        for (i = 0; i < GABuses.length; i++)
                            bs += GABuses[i] + " ";
                        bs += Lang.GetTranslation("at").trim() + " ";

                        LogGAHit(URL);
                        SetAd(StopNo);


                    } else {
                        Popup(Lang.GetTranslation('NoBusesRunning'));
                    }

                }

                AddRecent(StopNo, data.StopDescription, Agency, BusNo, BusDirection);
                
            }
        }
    })
    .fail(function () { Popup(Lang.GetTranslation('UnableToLoad')); })
    .always(function () { $.mobile.loading("hide"); });

}

function ShowBus(MarkNum, lnk) {

    $("#lvBuses").find('a').each(function () {
        $(this).removeClass('ui-btn-active');

    });
    $(lnk).addClass('ui-btn-active');

    if (MarkNum == -1) {
        $('#divBusMap').hide();
    } else {
   
        $('#divBusMap').show();
        $('html, body').animate({
            scrollTop: $("#divBusMap").offset().top
        }, 1500);

        
        BusMarkers[MarkNum].openPopup();
        bounds = L.latLngBounds(StopLatLong, BusMarkers[MarkNum].getLatLng());
        mymap.fitBounds(bounds.pad(0.5));
        
        
    }
}


function LoadBusMap(StopLat, StopLong, StopName, BusList) {

    if (BusList == '') {
        $('#divBusMap').hide();
        return;
    } else {
        $('#divBusMap').show();
    }



    StopLatLong = L.latLng(StopLat, StopLong);
    MapAds = new Array();

    if (typeof mymap == 'undefined') {
        mymap = L.map('divBusMap').setView([StopLat, StopLong], 13);

        MapLayer = L.tileLayer('https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token=pk.eyJ1IjoibWFwYm94IiwiYSI6ImNpandmbXliNDBjZWd2M2x6bDk3c2ZtOTkifQ._QA7i5Mpkd_m30IGElHziw', {
            maxZoom: 18,
            id: 'mapbox.streets'
        }).addTo(mymap);
    } else {
        for (x = 0; x < BusMarkers.length; x++)
            mymap.removeLayer(BusMarkers[x]);

        for (x = 0; x < KMZLayers.length; x++)
            mymap.removeLayer(KMZLayers[x]);

        mymap.removeLayer(StopMarker);
    }

    BusMarkers = [];
    KMZLayers = [];

    if (StopLat.length > 0) {
        var StopIcon = L.icon({
            iconUrl: 'images/busstop4.png',
            iconSize: [32, 34],
            iconAnchor: [16, 34]
        });

        var BusIcon = L.icon({
            iconUrl: 'images/bus_red.png',
            iconSize: [32, 37],
            iconAnchor: [16, 37]
        })


        StopMarker = L.marker(StopLatLong,
            {
                icon: StopIcon
            }).addTo(mymap);


        StopMarker.bindPopup(" <b>" + StopName + "</b> ");
    }


    var FirstLoad = true;

    for (x = 0; x < BusList.length; x++) {

        if (BusList[x].Lat == '')
            continue;

        if (FirstLoad) {
            Bounds = L.latLngBounds(StopLatLong, new L.latLng(BusList[x].Lat, BusList[x].Long));
            FirstLoad = false;
        }

        if (BusList[x].AdjustedScheduleTime == "1")
            var min = Lang.GetTranslation("Minute");
        else
            var min = Lang.GetTranslation("Minutes");

        if (BusList[x].Speed != '')
            var Speed = "<br />" + Lang.GetTranslation('Speed') + " " + BusList[x].Speed + " km/h";
        else
            var Speed = '';

        if (KMZs.length > 0) {
            $.each(KMZs, function (key, val) {
                var kmlLayer = new L.KML('https://bustracker.ca/ajax/kml.ashx?u=' + val, { async: true });
                mymap.addLayer(kmlLayer);
                KMZLayers.push(kmlLayer);
            })
        }

        var BusMarker = L.marker([BusList[x].Lat, BusList[x].Long], {
            icon: BusIcon,
            title: BusList[x].Number + " " + BusList[x].Destination + " " + Lang.GetTranslation('In') + BusList[x].AdjustedScheduleTime + ' ' + min + " " + BusList[x].BusTypeDescription + " " + Speed.replace("<br />",""),
            alt: '',
            riseOnHover: true
        }).addTo(mymap);


        BusMarker.bindTooltip("<b><span style='color:red'>#" + BusList[x].Number + "</span></b>", { permanent: true, className: "my-label", offset: [0, -25] });


        if (Lang.GetTranslation("AllowBusClick")) {
            BusMarker.bindPopup("<b>" + BusList[x].Number + " " + BusList[x].Destination + "</b> <br /> " + Lang.GetTranslation('In') + BusList[x].AdjustedScheduleTime + ' ' + min + "<br />" + BusList[x].BusTypeDescription + Speed);
        }

        BusMarkers.push(BusMarker);

    }

    window.setTimeout(function () {
        mymap.invalidateSize();
        if (typeof Bounds != 'undefined') {
            mymap.fitBounds(Bounds.pad(0.3));

        }
    }, 1000);

}



