﻿
function AddFavoriteStop(StopNo, StopName, Agency, SuppressPopup) {

    var RS = { "StopNo": StopNo, "StopName": StopName, "Agency": Agency};
    var bs = GetFavoriteStops();

    var Loc = -1;
    var Found = false;

    $.each(bs, function (index, val) {
        if (val.StopNo == RS.StopNo) {
            Loc = index;
            Found = true;
        }
    });
    if (!Found) {
        bs.splice(0, 0, RS);
    } else {
        bs.splice(Loc, 1);
    }


    SetFavoriteStops(bs);

    BuildFavoriteStopList();

    $('#aSaveFavoriteStop').toggleClass('ui-btn-active', !Found);

    if (typeof SuppressPopup == 'undefined' || !SuppressPopup)
        Popup(Found ? Lang.GetTranslation("RemovedFromFavorites") : Lang.GetTranslation("AddedToFavorites"))
}

function AddFavoriteBus(StopNo, StopName, BusNum, BusDirection, Agency, SuppressPopup) {
    var StopN = BusNum + Lang.GetTranslation('at') + StopName;
    var RS = { "StopNo": StopNo, "StopName": StopN, "Agency": Agency, "BusNum": BusNum, "BusDirection": BusDirection };
    var bs = GetFavoriteBuses();

    var Loc = -1;
    var Found = false;

    $.each(bs, function (index, val) {
        if (StopNo == val.StopNo && BusNum == val.BusNum && BusDirection == val.BusDirection) {
            Loc = index;
            Found = true;
        }
    });
    if (!Found) {
        bs.splice(0, 0, RS);
    } else {
        bs.splice(Loc, 1);
    }


    SetFavoriteBuses(bs);

    BuildFavoriteBusList();

    $('#aSaveFavoriteBus').toggleClass('ui-btn-active', !Found);

    if (typeof SuppressPopup == 'undefined' || !SuppressPopup)
        Popup(Found ? Lang.GetTranslation("RemovedFromFavorites") : Lang.GetTranslation("AddedToFavorites"))
}

function GetFavoriteStops() {
    var bs = [];
    if (!$.localStorage.isEmpty('FavoriteStops'))
        bs = $.localStorage.get('FavoriteStops');
    return bs;
}

function SetFavoriteStops(val) {
    return $.localStorage.set('FavoriteStops', val)
}

function GetFavoriteBuses() {
    var bs = [];
    if (!$.localStorage.isEmpty('FavoriteBuses'))
        bs = $.localStorage.get('FavoriteBuses');
    return bs;
}

function SetFavoriteBuses(val) {
    $.localStorage.set('FavoriteBuses', val)
}

function IsStopInFavorites(StopNo) {
    var ret = false;
    if (!$.localStorage.isEmpty('FavoriteStops') && $.localStorage.get('FavoriteStops') != '') {
        var bs = $.localStorage.get('FavoriteStops');
        $.each(bs, function (key, val) {
            if (StopNo == val.StopNo)
                ret = true;
        });
    }
    return ret;

}

function IsBusInFavorites(StopNo, BusNum, BusDirection) {
    var ret = false;
    var bs = GetFavoriteBuses();
    if (bs != '') {
        $.each(bs, function (key, val) {
            if (StopNo == val.StopNo && BusNum == val.BusNum && BusDirection == val.BusDirection)
                ret = true;
        });
    }
    return ret;

}

function BuildFavoriteStopList() {

    var bs = GetFavoriteStops();
    if (bs.length == 0) {
        $('#lvSavedStops').html("<li>" + Lang.GetTranslation('YouHaveNoSavedStops') + "</li>")
        if ($('#lvSavedStops').hasClass('ui-listview'))
            $('#lvSavedStops').listview("refresh");
    } else {
        var items = [];
        $.each(bs, function (key, val) {
            items.push(
                "<li><a href='javascript:GetStopBuses(" + val.StopNo + ", \"" + val.Agency + "\")'>" + val.StopName + "</a><a href='#FavoritesMenu' onclick='SetFavoriteStopEdit(" + key + ");' data-rel='popup' data-transition='pop'></a></li>"
            );
        });

        $("#lvSavedStops").html(items.join(''));
        if ($('#lvSavedStops').hasClass('ui-listview'))
            $('#lvSavedStops').listview("refresh");

    }
}

function BuildFavoriteBusList() {

    var bs = GetFavoriteBuses();
    if (bs.length == 0) {
        $('#lvSavedBuses').html("<li>" + Lang.GetTranslation('YouHaveNoSavedBuses') + "</li>")
        if ($('#lvSavedBuses').hasClass('ui-listview'))
            $('#lvSavedBuses').listview("refresh");
    } else {
        var items = [];
        $.each(bs, function (key, val) {
            items.push(
                "<li><a href='javascript:GetBuses(" + val.StopNo + ",\"" + val.BusNum + "\",\"" + val.BusDirection.replace("\"", "\\\"") + "\",\"" + val.Agency + "\")'>" + val.StopName + "</a><a href='#FavoritesMenuBus' onclick='SetFavoriteBusEdit(" + key + ");' data-rel='popup' data-transition='pop'></a></li>"
            );
        });

        $("#lvSavedBuses").html(items.join(''));
        if ($('#lvSavedBuses').hasClass('ui-listview'))
            $('#lvSavedBuses').listview("refresh");

    }
}

function SetFavoriteStopEdit(num) {
    $.localStorage.set('FavoriteStopEdit', num);
}

function GetFavoriteStopEdit() {
    return $.localStorage.get('FavoriteStopEdit');
}

function SetFavoriteBusEdit(num) {
    $.localStorage.set('FavoriteBusEdit', num);
}

function GetFavoriteBusEdit() {
    return $.localStorage.get('FavoriteBusEdit');
}

function MoveFavoriteStopUp() {
    var num = GetFavoriteStopEdit();
    bs = GetFavoriteStops();
    if (num != 0) {
        bs.move(num, num - 1);
        SetFavoriteStops(bs);
        SetFavoriteStopEdit(num - 1);
        BuildFavoriteStopList();
    }
}

function MoveFavoriteStopDown() {
    var num = GetFavoriteStopEdit();
    bs = GetFavoriteStops();
    if (num != bs.length - 1) {
        bs.move(num, num + 1);
        SetFavoriteStops(bs);
        SetFavoriteStopEdit(num + 1);
        BuildFavoriteStopList();
    }
}

function EditFavoriteStop() {
   
    bs = GetFavoriteStops();
    $('#txtEditStop').val(bs[GetFavoriteStopEdit()].StopName);
    $("#FavoritesMenu").on("popupafterclose", function () {
        //any action you want like opening another popup
        $('#divEditStop').popup();
        $('#divEditStop').popup("open", { theme: 'a' });
        $('#FavoritesMenu').unbind("popupafterclose");

    })
    
    $('#FavoritesMenu').popup('close');

    
  
}

function RenameStop() {
    bs = GetFavoriteStops();
    bs[GetFavoriteStopEdit()].StopName = $('#txtEditStop').val();
    SetFavoriteStops(bs);
    BuildFavoriteStopList();
    $('#divEditStop').popup("close");

}

function DeleteFavoriteStop() {
    var num = GetFavoriteStopEdit();
    bs = GetFavoriteStops();
    bs.splice(num, 1);
    SetFavoriteStops(bs);
    BuildFavoriteStopList();
    window.history.back();
}

function MoveFavoriteBusUp() {
    var num = GetFavoriteBusEdit();
    bs = GetFavoriteBuses();
    if (num != 0) {
        bs.move(num, num - 1);
        SetFavoriteBuses(bs);
        SetFavoriteBusEdit(num - 1);
        BuildFavoriteBusList();
    }
}

function MoveFavoriteBusDown() {
    var num = GetFavoriteBusEdit();
    bs = GetFavoriteBuses();
    if (num != bs.length - 1) {
        bs.move(num, num + 1);
        SetFavoriteBuses(bs);
        SetFavoriteBusEdit(num + 1);
        BuildFavoriteBusList();
    }
}

function EditFavoriteBus() {

    bs = GetFavoriteBuses();
    $('#txtEditBus').val(bs[GetFavoriteBusEdit()].StopName);
    $("#FavoritesMenuBus").on("popupafterclose", function () {
        //any action you want like opening another popup
        $('#divEditBus').popup();
        $('#divEditBus').popup("open", { theme: 'a' });
        $('#FavoritesMenuBus').unbind("popupafterclose");

    })

    $('#FavoritesMenuBus').popup('close');



}

function RenameBus() {
    bs = GetFavoriteBuses();
    bs[GetFavoriteBusEdit()].StopName = $('#txtEditBus').val();
    SetFavoriteBuses(bs);
    BuildFavoriteBusList();
    $('#divEditBus').popup("close");

}

function DeleteFavoriteBus() {
    var num = GetFavoriteBusEdit();
    bs = GetFavoriteBuses();
    bs.splice(num, 1);
    SetFavoriteBuses(bs);
    BuildFavoriteBusList();
    window.history.back();
}
