﻿function AddRecent(StopNo, StopName, Agency, BusNum, BusDirection) {

    if (typeof BusNum != 'undefined')
        var StopName = BusNum + Lang.GetTranslation('at') + StopName;

    var RS = { "StopNo": StopNo, "StopName": StopName, "Agency": Agency, "BusNum": BusNum, "BusDirection": BusDirection  };
    var bs = [RS];

    if (!$.localStorage.isEmpty('RecentBuses')) {
        bs = $.localStorage.get('RecentBuses');
        var found = false;

        $.each(bs, function (index, val) {
            if (val.StopNo == RS.StopNo && val.BusNum == RS.BusNum && val.BusDirection == RS.BusDirection) {
                bs.move(index, 0);
                found = true;
                return false;

            }
        });

        if (!found) {
            bs.splice(0, 0, RS);
            if(bs.length > 5){
                bs.splice(bs.length-1, 1);
            }
        }
        
    }

    $.localStorage.set('RecentBuses', bs);

    BuildRecentList();
}

function BuildRecentList() {

    if ($.localStorage.isEmpty('RecentBuses')) {
        $('#lvRecent').html("<li>" + Lang.GetTranslation('YouHaveNoRecent') + "</li>")
        if ($('#lvRecent').hasClass('ui-listview'))
            $('#lvRecent').listview("refresh");
    } else {
        var bs = $.localStorage.get('RecentBuses');
        var items = [];
        $.each(bs, function (key, val) {
            if (typeof val.BusNum != 'undefined')
                items.push(CreateRecentBusLI(val, val.Agency));
            else
                items.push(CreateRecentStopLI(val, val.Agency));
        });

        $("#lvRecent").html(items.join(''));
        if ($('#lvRecent').hasClass('ui-listview'))
            $('#lvRecent').listview("refresh");
        


    }
}

function CreateRecentStopLI(Stop, Agency) {

    return "<li><a href='javascript:GetStopBuses(" + Stop.StopNo + ", \"" + Agency + "\")' class='ui-btn ui-btn-inline ui-btn-icon-right ui-icon-carat-r'>" + Stop.StopName + "</a></li>";
}

function CreateRecentBusLI(Bus, Agency) {
    return "<li><a href='javascript:GetBuses(" + Bus.StopNo + ",\"" + Bus.BusNum + "\",\"" + Bus.BusDirection.replace("\"","\\\"") + "\", \"" + Bus.Agency + "\")' class='ui-btn ui-btn-inline ui-btn-icon-right ui-icon-carat-r'>" + Bus.StopName + "</a></li>";
}