﻿

SelectedBuses = [];
CurrStop = '';
CurrAgency = '';
function GetStopBuses(StopNo, Agency) {

    SelectedBuses = [];
    

    $('#aGetMultiple').hide();

    if (StopNo == null) {
        StopNo = $('#txtSearch').val();
        if (StopNo.trim().length == 0) {
            Popup(Lang.GetTranslation('PleasePutStopNumber'));
            return;
        }
        Agency = Lang.GetTranslation("Agency");
    }

    if (isNaN(StopNo)) {
        if (StopNo.indexOf(" - ") > 0)
            StopNo = StopNo.split(" - ")[1];
    }

    //### Leading zeroes don't work well with JS numbers
    try{
        StopNo = StopNo.replace(/^0+/, '');
    }catch(err){}

    CurrStop = StopNo;
    CurrAgency = Agency;

    $.mobile.loading("show", {
        text: Lang.GetTranslation('RetrievingBuses'),
        textVisible: true,
        theme: "a",
        html: ""
    });
    var URL = 'https://www.BusTracker.ca/ajax/StopAPI.ashx?StopNo=' + StopNo + "&Agency=" + Agency;

    $.ajax({
        dataType: 'json',
        url: URL,
        timeout: 12000,
        success: function (data) {
            if (data.StopName == '') {
                Popup(Lang.GetTranslation('NoStop'));
            } else {
                if (data.buses == '') {
                    Popup(Lang.GetTranslation('NoStopBuses'));
                } else if (typeof data.Error != "undefined") {
                    Popup(Lang.GetTranslation("FeedDown"));
                } else {

                    $('#h1StopBusesTitle').text(data.StopName);

                    var items = [];
                    $.each(data.buses, function (key, val) {
                        var href = "javascript:GetBuses(" + StopNo + ",\"" + val.Number + "\",\"" + val.direction.replace("\"", "\\\"") + "\",\"" + Agency + "\")";
                        items.push("<li id='" + key + "'><a href='" + href + "'>" + val.Number + " " + val.RouteHeadingClean + "</a><a id='t" + key + "' href='#' onclick=\"javascript:AddBus('" + key + "', '" + val.Number + "','" + val.direction.replace("'", "\'") + "');\"></a></li>");
                    });

                    $("#lvStopBuses").html(items.join(''));
                    if ($('#lvStopBuses').hasClass('ui-listview'))
                        $('#lvStopBuses').listview("refresh");

                    $('#aSaveFavoriteStop').unbind('click');
                    $('#aSaveFavoriteStop').click(function () { AddFavoriteStop(StopNo, data.StopName, Agency) });
                    $('#aSaveFavoriteStop').toggleClass('ui-btn-active', IsStopInFavorites(StopNo));

                    $('#aBackStopBuses').removeClass('ui-btn-active');

                    jQuery.mobile.changePage('#pgStopBuses');

                    LogGAHit(URL);
                    SetAd(StopNo);
                    
                }

                AddRecent(StopNo, data.StopName, Agency);
            }
        }
    })
    .fail(function () { Popup(Lang.GetTranslation('UnableToLoad')); })
    .always(function () { $.mobile.loading("hide"); });

}

function AddBus(lnk, num, direction) {

    var obj = $('#t' + lnk);
    obj.toggleClass('ui-btn-active');

    if (obj.hasClass('ui-btn-active')) {
        //### Add Bus
        SelectedBuses.push({'Num': num, 'Direction': direction})
    } else {
        //### Delete Bus
        $.each(SelectedBuses, function (key, val) {
            if (val.Num == num && val.Direction == direction) {
                SelectedBuses.splice(key, 1);
            }
        });
    }

    if (SelectedBuses != '')
        $('#aGetMultiple').show();
    else
        $('#aGetMultiple').hide();

       
}

function GetMultiple() {

    var BA = '';
    var DA = '';
    $.each(SelectedBuses, function (key, val) {
        BA += val.Num + ',';
        DA += val.Direction + ',';
    });
    BA = BA.slice(0, -1);
    DA = DA.slice(0, -1);
    GetBuses(CurrStop, BA, DA, CurrAgency);

}

